package com.sky.activate.tool;

public class Constant {

    /** 模拟聚划算高并发解决方案 **/
    public final static String JHS_KEY_A = "jhs_A";
    public final static String JHS_KEY_B = "jhs_B";

    /** 模拟微博排行榜 **/
    public final static String HOT_RANK_LIST_HOUR_KEY = "hot_rank_list_hour_key";
    public final static String HOT_RANK_LIST_DAY_KEY = "hot_rank_list_day_key";
    public final static String HOT_RANK_LIST_WEEK_KEY = "hot_rank_list_week_key";
    public final static String HOT_RANK_LIST_MONTH_KEY = "hot_rank_list_month_key";

    /** JWT ACCESS 密钥加密 **/
    public final static String JWT_ACCESS_PRIVATE_KEY = "SKYVERSATION-ACCESS";
    /** JWT REFRESH 密钥加密 **/
    public final static String JWT_REFRESH_PRIVATE_KEY = "SKYVERSATION-REFRESH";
    /** redis保存access_token的key的头 **/
    public final static String REDIS_USER_ACCESS_HEADER = "USER_ACCESS_TOKEN::";
    /** redis保存refresh_token的key的头 **/
    public final static String REDIS_USER_REFRESH_HEADER = "USER_REFRESH_TOKEN::";
    /** redis保存用户权限信息的key的头**/
    public final static String REDIS_USER_USERID_HEADER="USER_USERID::";

    /** Role Permission 角色、权限数据刷新时间 **/
    public final static long ROLE_PERMISSION_REFRESH_TIME = 1000 * 60;

    /** 游客权限 **/
    public final static String VISITOR_PERMISSION = "1";
    /** 普通用户权限 **/
    public final static String GENERAL_PERMISSION = "1,2,7,11,17,20,23";
    /** 角色管理员权限 **/
    public final static String ROLE_MANAGER_PERMISSION = "3,4,8,13,18,21,25";
    /** 系统管理员权限 **/
    public final static String SYSTEM_MANAGER_PERMISSION = "5,9,10,12,14,15,19,22";
    /** 超级管理员权限 **/
    public final static String SUPER_MANAGER_PERMISSION = "27";

    /** 无超管权限*/
    public final static int NO_SYSDBA_PERMISSION = 600;

    /** 游客有效时间 **/
    public final static long VISITOR_TIME = 1000 * 60 * 60 * 24 * 365;
    /**  普通用户有效时间 **/
    public final static long GENERAL_TIME = 1000 * 60 * 60 * 24 * 365;
    /**  角色管理员有效时间 **/
    public final static long ROLE_MANAGER_TIME = 1000 * 60 * 60 * 24 * 365 * 2;
    /**  系统管理员有效时间 **/
    public final static long SYSTEM_MANAGER_TIME = 1000 * 60 * 60 * 24 * 365 * 2;
    /**  超级管理员有效时间 **/
    public final static long SUPER_MANAGER_TIME = 1000 * 60 * 60 * 24 * 365 * 3;

    /** access token 有效时间 **/
    public final static long ACCESS_TOKEN_TIME = 1000 * 60 * 60 * 24;
    /** refresh token 有效时间 **/
    public final static long REFRESH_TOKEN_TIME = 1000 * 60 * 60 * 24 * 7;


    /** 网络请求返回值 **/
    public final static int SUCCESS = 200;
    /** 参数错误 **/
    public final static int PARAM_ERROR = -1;
    /** 服务端错误 **/
    public final static int SERVER_ERROR = 500;
    /** 无权限 **/
    public final static int NO_PERMISSION = 201;
    /** 数据错误，无数据 **/
    public final static int NO_DATA = 202;
    /** 内部错误 **/
    public final static int INTER_ERROR = 203;
    /** 数据库错误 **/
    public final static int DATABASE_ERROR = 204;
    /** 数据为空 **/
    public final static int NULL_DATA = 205;
    /** 用户过期 **/
    public final static int USER_FAILURE = 206;
    /** 用户失效 **/
    public final static int USER_ARCHIVED = 207;
    /** 无token **/
    public final static int NO_TOKEN = 208;
    /** 无效token **/
    public final static int FAILURE_TOKEN = 212;

//    public final static String[] TABLE_NAME = new String[]{
//            "http://localhost:10086/oauth/user/getUserByToken",
//            "http://localhost:10086/oauth/record/addRecord",
//            "http://localhost:10086/oauth/user/getUserRolePermission",
//            "http://localhost:10086/oauth/permission/updatePermission",
//            "http://localhost:10086/oauth/permission/addRoleAndPermission"};


    public final static String[] METADATA_URL_NAME = new String[]{
            "http://localhost:10086/user/getUserByToken",
            "http://localhost:10086/record/addRecord",
            "http://localhost:10086/user/getUserRolePermission",
            "http://localhost:10086/permission/updatePermission",
            "http://localhost:10086/permission/addRoleAndPermission"};




    final static int [] sizeTable = { 9, 99, 999, 9999, 99999, 999999, 9999999, 99999999, 999999999, Integer.MAX_VALUE };

    // Requires positive x
    public final static int STRINGSIZE(int x) {
        for (int i=0; ; i++)
            if (x <= sizeTable[i])
                return i+1;
    }

}
